##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""SQL OID generator

$Id: oidgen.py,v 1.1 2004/06/28 18:08:30 johanc Exp $
"""

from apelib.core import interfaces

import sqlbase


class SQLOIDGenerator (sqlbase.SQLGatewayBase):

    __implements__ = (interfaces.IOIDGenerator,
                      interfaces.IDatabaseInitializer)

    table = 'oid_seq'
    column_defs = ()
    root_oid = "0"

    def init(self, event):
        conn = self.get_connection(event)
        if not conn.exists(self.table, 'sequence'):
            conn.create_sequence(self.table, start=1)
        elif event.clear_all:
            conn.reset_sequence(self.table, start=1)

    def new_oid(self, event):
        assert interfaces.IGatewayEvent.isImplementedBy(event)
        conn = self.get_connection(event)
        n = conn.increment(self.table)
        return str(n)
