##############################################################################
#
# Copyright (c) 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
"""Configuration of storage types for DBTab/ZODB

$Id: dbtab.py,v 1.1 2004/06/28 18:08:30 johanc Exp $
"""

def convert_ape_storage_args(name, factory=None, **kw):
    from apelib.zodb3.db import call_conf_factory
    from apelib.zodb3.resource import StaticResource
    if factory is None:
        raise ValueError('factory is required')
    conf, connections = call_conf_factory(factory, kw)
    return {
        'conf_resource': StaticResource(conf),
        'connections': connections,
        'name': name,
        }

try:
    from Products.DBTab.StorageTypes import storage_types
    from Products.DBTab.DBTab import database_types
except ImportError:
    pass
else:
    storage_types['ApeStorage'] = (
        'apelib.zodb3.storage', convert_ape_storage_args)
    database_types['ApeDB'] = 'apelib.zodb3.db'

