# $Header usrcustomcvspublicEnergyPlusLivelibpythonProductsEasyCoreEasyTypeRegistry.py,v 1.1 20030610 095101 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 andor
# the Easy Publisher Enterprise License 2.0 andor the Easy Publisher Developers License 2.0
# andor the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="EasyApplicationTypeRegistry"
__version__='$Revision 1.1 $'[11-2]


import Globals
from App.ProductContext import ProductContext
from Products.EasyCore import MLOG_TAB


class EasyApplicationMetaTypeInformation:

    def __init__(self, instance_class):
        self.__instance_class=instance_class
        self.meta_type=instance_class.meta_type

    def isWorkflowable(self):
        return getattr(self.__instance_class, '_workflowable', 0)


class EasyApplicationTypeRegistrySingleton:

    def __init__(self):
        self.__registry={}

    def registerType(self, type_info):
        self.__registry[type_info.meta_type]=type_info


    def getWorkflowableTypes(self):
        wflowable=[]
        for meta_type, t_info in self.__registry.items():
            isWorkflowable=getattr(t_info, 'isWorkflowable', None)
            isWorkflowable=callable(isWorkflowable)
            if isWorkflowable:
                wflowable.append(meta_type)
        return wflowable



EasyApplicationTypeRegistry=EasyApplicationTypeRegistrySingleton()


class _ProductContextPatch:
    def registerEasyApplicationType(self, instance_class):
        mt_information=EasyApplicationMetaTypeInformation(instance_class)
        EasyApplicationTypeRegistry.registerType(mt_information)

ProductContext.__dict__.update(_ProductContextPatch.__dict__)