# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyApplication/EasySecurityConf.py,v 1.1 2004/06/28 10:04:08 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__ = """\
EasySecurityConf contains the permissions declarations for
EasyApplication.
"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals, AccessControl, Products
from AccessControl import Permissions
from Products.CMFCore import CMFCorePermissions

# General Zope permissions
View = Permissions.view
AccessContentsInformation = Permissions.access_contents_information
UndoChanges = Permissions.undo_changes
ChangePermissions = Permissions.change_permissions
ViewManagementScreens = Permissions.view_management_screens
ManageProperties = Permissions.manage_properties
FTPAccess = Permissions.ftp_access
ManageUsers = Permissions.manage_users
DeleteObjects = Permissions.delete_objects

def setDefaultRoles(permission, roles):
    '''
    Sets the defaults roles for a permission.
    '''
    # XXX This ought to be in AccessControl.SecurityInfo.
    registered = AccessControl.Permission._registeredPermissions
    if not registered.has_key(permission):
        registered[permission] = 1
        Products.__ac_permissions__=(
            Products.__ac_permissions__+((permission,(),roles),))
        mangled = AccessControl.Permission.pname(permission)
        setattr(Globals.ApplicationDefaultPermissions, mangled, roles)


# Setting defaults for Zope Core Permissions
# Called on EasyRoot DB init
#def setupZopeCorePermissions():
#    permission = AccessControl.Permission.pname(AccessContentsInformation)
#    setattr(Globals.ApplicationDefaultPermissions, permission, ('Anonymous', 'Manager', 'Author', 'Reviewer',))


#
# Easy Application Core Permissions
#

#EasyAppObject
EasyApplicationObjectAdd = 'Easy Application Object Add'
setDefaultRoles(EasyApplicationObjectAdd, ('Manager', 'Application Manager', 'Application User'))

EasyApplicationObjectChange = 'Easy Application Object Change'
setDefaultRoles(EasyApplicationObjectChange, ('Manager', 'Application Manager', 'Application User'))

EasyApplicationObjectRemove = 'Easy Application Object Remove'
setDefaultRoles(EasyApplicationObjectRemove, ('Manager', 'Application Manager', 'Application User'))

EasyApplicationObjectView = 'Easy Application Object View'
setDefaultRoles(EasyApplicationObjectView, ('Manager', 'Application Manager', 'Application User'))

EasyApplicationManage = 'Easy Application Manage'
setDefaultRoles(EasyApplicationManage, ('Manager', 'Application Manager'))

EasyApplicationViewManagementViews = 'Easy Application View Management Views'
setDefaultRoles(EasyApplicationViewManagementViews, ('Manager', 'Application Manager', 'Application User'))

#EasyApplicationWorkflowPublish = 'Easy Application Workflow Publish'
#setDefaultRoles(EasyApplicationWorkflowPublish, ('Manager', 'Application Manager', 'Application User'))
#EasyApplicationWorkflowSubmit = 'Easy Application Workflow Submit'
#setDefaultRoles(EasyApplicationWorkflowSubmit, ('Manager', 'Application Manager', 'Application User'))
#EasyApplicationWorkflowChangeDates = 'Easy Application Workflow ChangeDates'
#setDefaultRoles(EasyApplicationWorkflowChangeDates, ('Manager', 'Application Manager', 'Application User'))


#EasyApplication
EasyApplicationAdd = 'Easy Application Add'
setDefaultRoles(EasyApplicationAdd, ('Manager', 'Application Manager'))

#EasyObjectAdd = 'Easy Object Add'
#setDefaultRoles(EasyObjectAdd, ('Manager', 'Application Manager'))


#EasyObjectTemplate
EasyApplicationClassManage = 'Easy Application Class Manage'
setDefaultRoles(EasyApplicationClassManage, ('Manager', 'Application Manager'))





