# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyApplication/EasyViews/EasyDataView.py,v 1.1 2004/06/28 10:04:08 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__='''EasyApplication EasyViews.EasyDataView'''
__version__='$Revision: 1.1 $'[11:-2]

import Globals, Products
from Globals import DTMLFile
from Acquisition import aq_chain, aq_inner, aq_parent
from AccessControl import ClassSecurityInfo

from OFS.Folder import Folder

#EasyCore
from Products.EasyCore.interfaces.EasyIcon import EasyIconInterface
from Products.EasyCore.EasyIcon import EasyIcon
from Products.EasyCore.BodyTabs import InitializeBodyTabs, UpdateTab, BodyTabs
from Products.EasyCore.ClassWrappers import DTMLFileWrapper, FunctionTemplate
from Products.EasyCore.VirtualPath import VirtualPathBase

#EasyApplication
from Products.EasyApplication.EasyViews.EasyViewBase import EasyViewBase
from Products.EasyApplication.EasySecurityConf import *

#Interfaces
from Products.EasyApplication.interfaces.EasyApplication import EasyObjectTemplate
from Products.EasyApplication.interfaces.EasyApplication import EasyPluggableView, EasyPluggableDataSheet
from Products.EasyCore.interfaces.EasyIcon import EasyIconInterface


from Products.EasyCore import MLOG_TAB




class EasyDataView(EasyViewBase):
    """Web application main class"""

    security = ClassSecurityInfo()

    meta_type = "EasyDataView"
    title=''

    _product_interfaces = (EasyIconInterface, EasyPluggableDataSheet, EasyPluggableView)

    id_prefix=''
    is_a_folder = 0
    enable_workflow_view = 0
    enable_publish_view=0
    is_a_wizard=0

    manage_options = EasyViewBase.manage_options

    _properties = EasyViewBase._properties
    #                                + (
    #                                    {'id':'isVisible',            'label':'Is Visible', 'type':'boolean', 'mode':'w'},
    #                                  )


    __interfaces__=(EasyPluggableView,)


    def __init__(self, id, title=''):
        self.id = id
        self.title = title


Globals.InitializeClass(EasyDataView)
InitializeBodyTabs(EasyDataView)

manage_addEasyDataViewForm = DTMLFile('dtml/manage_addEasyDataViewForm', globals())

def manage_addEasyDataView(self, id, title='', REQUEST=None):
    """Add a EasyApplication object"""
    ob=EasyDataView(id, title)
    self._setObject(id, ob)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


def initialize(context):
    """Initialize StyleManagers Product"""

    context.registerClass(
        EasyDataView,
        permission=EasyApplicationClassManage,
        icon='icons/EasyDataView.gif',
        constructors = ( manage_addEasyDataViewForm, manage_addEasyDataView ),
        meta_type = EasyDataView.meta_type,
        visibility = None,
    )



