# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyApplication/__init__.py,v 1.2 2004/06/29 08:21:13 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__ = """EasyApplication"""
__version__='$Revision: 1.2 $'[11:-2]


import os

from Products.EasyCore import MLOG_TAB, C_MLOG_TAB


import EasyApplication
include_modules = (EasyApplication, )

import EasyApplicationConf
include_modules = include_modules+(EasyApplicationConf, )

import  EasyObject, EasyObjectTemplate, EasyPropertySheet
include_modules = include_modules+(EasyObject, EasyObjectTemplate, EasyPropertySheet, )


import EasyApplicationTypeRegistry

def initialize(context):
    """\
    Initialize the EasyApplication product.
    """
    for m in include_modules:
            m.initialize(context)

    context.registerHelp()

import EasyViews

from App.FactoryDispatcher import FactoryDispatcher

import Acquisition, sys, Products
from AccessControl.PermissionMapping import aqwrap
import ExtensionClass
from Products.EasyApplication.EasyApplicationGlobals import EasyAppConfigId

class ofWrapper(ExtensionClass.Base):
    def __init__(self, o):
        self._o=o

    def __of__(self, parent): return self.__dict__['_o']


class __FactoryDispatcher__(FactoryDispatcher):
    """Overrides the factory dispatcher to enable adding of
       the same meta_types under different names"""

    def __getattr__(self, name):
        p=self.__dict__['_product']
        d=p.__dict__
        if hasattr(p,name) and d.has_key(name):
            m=d[name]
            w=getattr(m, '_permissionMapper', None)
            if w is not None:
                m=ofWrapper(aqwrap(m, getattr(w,'aq_base',w), self))

            return m

        m='Products.%s' % p.id
        if sys.modules.has_key(m) and sys.modules[m]._m.has_key(name):
            return sys.modules[m]._m[name]

        if self.__dict__.has_key('_v_in_getattr') and self.__dict__['_v_in_getattr'] != None:
            # Only look through the products if we isn't doing that already, to prevent recursivness
            self.__dict__['_v_in_getattr'] == None
            raise AttributeError, name

        self.__dict__['_v_in_getattr'] = 1

        products = getattr(getattr(self.__dict__['_d'], EasyAppConfigId), 'getAllTemplates')()
        self.__dict__['_v_in_getattr'] = None
        for product in products:
            if product['id'] == name:
                self.subclass_title = product['title']
                self.subclass = name
                m='Products.%s' % p.id
                if sys.modules.has_key(m) and sys.modules[m]._m.has_key('manage_addEasyObjectForm'):
                    return sys.modules[m]._m['manage_addEasyObjectForm']

        #if name[0:2]=='c_':
        #    name=name[2:]
        #    for product in products:
        #        if product['id'] == name:
        #            self.subclass_title = product['title']
        #            self.subclass = name
        #            #return self
        #            #return


        raise AttributeError, name
