# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/EasyService.py,v 1.1 2004/06/28 10:04:10 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__='''EasyThreadedService'''
__version__='$Revision: 1.1 $'[11:-2]


from threading import Thread
import ThreadedAsync

#import Globals, Products, Acquisition
#from Globals import DTMLFile

import Globals
import AccessControl.SecurityManagement, AccessControl.User
import ZODB, ZODB.ZApplication
import OFS.Application

from Prodcuts.EasyCore import MLOG_TAB


class EasyThreadedService(Thread):

    def __init__(self, group=None, target=None, name=None, args=(), kwargs=None):
        if kwargs is None: kwargs={}
        Thread.__init__(self, group=group, target=target, name=name, args=args, kwargs=kwargs)
        self.setDaemon(1)
        ThreadedAsync.register_loop_callback(self.becomeAsync)

    def becomeAsync(self,map):
        self.start()


def runner(event, func, interval=120, *args, **kw):
    import Globals
    DB=Globals.DB
    #conn=DB.open()
    #root=conn.root()
    #app=root.get('Application', None)

    AccessControl.SecurityManagement.newSecurityManager(None, AccessControl.User.system)
    app=ZODB.ZApplication.ZApplicationWrapper(
            DB, 'Application', OFS.Application.Application, (),
            Globals.VersionNameName)
    AccessControl.SecurityManagement.noSecurityManager()

    while app is not None:
        loop_app = app()

        MLOG_TAB("Tick")

        loop_app._p_jar.close()
        del loop_app

        event.wait(float(interval)) # in seconds (float)
        if event.isSet():
            event.clear()

    try:
        loop_app._p_jar.close()
        del loop_app
    except:
        pass



