# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/ExtendedHTMLParser.py,v 1.1 2004/06/28 10:04:10 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""ExtendedHTMLParser

$Colliberty: Storage.py,v 0.0.1 2001/05/14 22:06:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]

#from htmllib import HTMLParser
from sgmllib import SGMLParser
#import ExtensionClass

class ExtendedHTMLParser(SGMLParser):

    def __init__(self, formater, verbose=0):
        #ExtendedHTMLParser.inheritedAttribute('__init__')(self, verbose=verbose)
        SGMLParser.__init__(self, verbose=verbose)

    #def finish_shorttag(self, tag, data):
    #    SGMLParser.finish_shorttag(self, tag, data)

    #def finish_starttag(self, tag, attrs):
    #    SGMLParser.finish_starttag(self, tag, attrs)

    #def finish_endtag(self, tag):
    #    SGMLParser.finish_endtag(self, tag)

    #def handle_starttag(self, tag, method, attrs):
    #    method(attrs)
    #
    #def handle_endtag(self, tag, method):
    #    method()

    def start_default(self, tag, attrs): pass
    def end_default(self, tag): pass

    def unknown_starttag(self, tag, attrs): pass
    def unknown_endtag(self, tag): pass

    def start_br(self, attrs): self.start_default('br', attrs)

    def start_hr(self, attrs): self.start_default('hr', attrs)

    def start_img(self, attrs): self.start_default('img', attrs)

    def start_p(self, attrs): self.start_default('p', attrs)
    def end_p(self): self.end_default('p')

    def start_div(self, attrs): self.start_default('div', attrs)
    def end_div(self): self.end_default('div')

    def start_span(self, attrs): self.start_default('span', attrs)
    def end_span(self): self.end_default('span')

    def start_li(self, attrs): self.start_default('li', attrs)
    def end_li(self): self.end_default('li')

    def start_ol(self, attrs): self.start_default('ol', attrs)
    def end_ol(self): self.end_default('ol')

    def start_ul(self, attrs): self.start_default('ul', attrs)
    def end_ul(self): self.end_default('ul')

    def start_table(self, attrs): self.start_default('table', attrs)
    def end_table(self): self.end_default('table')

    def start_tr(self, attrs): self.start_default('tr', attrs)
    def end_tr(self): self.end_default('tr')

    def start_thead(self, attrs): self.start_default('thead', attrs)
    def end_thead(self): self.end_default('thead')

    def start_tbody(self, attrs): self.start_default('tbody', attrs)
    def end_tbody(self): self.end_default('tbody')

    def start_th(self, attrs): self.start_default('th', attrs)
    def end_th(self): self.end_default('th')

    def start_td(self, attrs): self.start_default('td', attrs)
    def end_td(self): self.end_default('td')


    def start_html(self, attrs): self.start_default('html', attrs)
    def end_html(self): self.end_default('html')

    def start_head(self, attrs): self.start_default('head', attrs)
    def end_head(self): self.end_default('head')

    def start_body(self, attrs): self.start_default('body', attrs)
    def end_body(self): self.end_default('body')

    def start_title(self, attrs):self.start_default('title', attrs)
    def end_title(self):self.end_default('title')

    def start_h1(self, attrs):self.start_default('h1', attrs)
    def end_h1(self):self.end_default('h1')

    def start_h2(self, attrs):self.start_default('h2', attrs)
    def end_h2(self):self.end_default('h2')

    def start_h3(self, attrs):self.start_default('h3', attrs)
    def end_h3(self):self.end_default('h3')

    def start_h4(self, attrs):self.start_default('h4', attrs)
    def end_h4(self):self.end_default('h4')

    def start_h5(self, attrs):self.start_default('h5', attrs)
    def end_h5(self):self.end_default('h5')

    def start_h6(self, attrs):self.start_default('h6', attrs)
    def end_h6(self):self.end_default('h6')

    def start_pre(self, attrs):self.start_default('pre', attrs)
    def end_pre(self):self.end_default('pre')

    def start_xmp(self, attrs):self.start_default('xmp', attrs)
    def end_xmp(self):self.end_default('xmp')

    def start_listing(self, attrs):self.start_default('listing', attrs)
    def end_listing(self):self.end_default('listing')

    def start_address(self, attrs):self.start_default('address', attrs)
    def end_address(self):self.end_default('address')

    def start_blockquote(self, attrs):self.start_default('blockquote', attrs)
    def end_blockquote(self):self.end_default('blockquote')

    def start_menu(self, attrs):self.start_default('menu', attrs)
    def end_menu(self):self.end_default('menu')

    def start_dir(self, attrs):self.start_default('dir', attrs)
    def end_dir(self):self.end_default('dir')

    def start_dl(self, attrs):self.start_default('dl', attrs)
    def end_dl(self):self.end_default('dl')

    def start_i(self, attrs): self.start_em(attrs)
    def end_i(self): self.end_em(attrs)

    def start_em(self, attrs): self.start_default('em', attrs)
    def end_em(self): self.end_default('em')

    def start_b(self, attrs): self.start_strong(attrs)
    def end_b(self): self.end_strong(attrs)

    def start_strong(self, attrs): self.start_default('strong', attrs)
    def end_strong(self): self.end_default('strong')

    def start_tt(self, attrs): self.start_default('tt', attrs)
    def end_tt(self): self.end_default('tt')

    def start_a(self, attrs): self.start_default('a', attrs)
    def end_a(self): self.end_default('a')

