# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/ManageOptionBase.py,v 1.1 2004/06/28 10:04:10 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""ManageOptionBase Object
$Colliberty: ManageOptionBase.py,v 1.7 2001/09/29 14:48:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from AccessControl import ClassSecurityInfo
from ExtensionClass import Base
from Products.EasyCore.EasyCorePermissions import *

from zLOG import LOG, ERROR

from Acquisition import aq_chain,aq_base


class ManageOptionBase(Base):

    security = ClassSecurityInfo()

    security.declareProtected(ViewManagementScreens, 'manage_options')
    def manage_options(self):
        left_options = ()
        middle_options = ()
        right_options = ()
        use_manage_options=self.use_manage_options
        if callable(use_manage_options): use_manage_options=use_manage_options()
        for left, middle, right in use_manage_options:
            if callable(left): left = left(self)
            if callable(middle): middle = middle(self)
            if callable(right): right = right(self)
            if left: left_options = left_options + left
            if middle: middle_options = middle_options + middle
            if right: right_options = right_options + right
        return left_options + middle_options + right_options

Globals.InitializeClass(ManageOptionBase)

