# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/ObjectManager/OrderedObjectManager.py,v 1.1 2004/06/28 10:04:11 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__ = """EasyCore.ObjectManager.OrderedObjectManager"""
__version__='$Revision: 1.1 $'[11:-2]

import Globals
from Globals import DTMLFile
from types import StringType
from AccessControl import ClassSecurityInfo
from OFS.ObjectManager import ObjectManager

from Products.EasyCore.EasySortable.EasySortable import EasySortable

from App.version_txt import getZopeVersion
zope_version=getZopeVersion()

from Products.EasyCore.Utils.DebugUtils import MLOG_TAB

ViewManagementScreens='View management screens'


class OrderedObjectManager(EasySortable, ObjectManager):


    security = ClassSecurityInfo()


    manage_options=({'label':'Contents', 'action':'manage_main',},)


    security.declareProtected(ViewManagementScreens, 'manage_main')
    if zope_version[0:3]>=(2,5,1) and zope_version[0:3]<(2,6,1):
        manage_main=DTMLFile('dtml/251/ordered_manage_main', globals())
    elif zope_version[0:3]>=(2,6,1) and zope_version[0:3]<(2,7,0):
        manage_main=DTMLFile('dtml/261/ordered_manage_main', globals())
    elif zope_version[0:3]==(2,6,2):
        manage_main=DTMLFile('dtml/262/ordered_manage_main', globals())
    elif zope_version[0:3]==(2,7,0):
        manage_main=DTMLFile('dtml/270/ordered_manage_main', globals())
    else:
        manage_main=DTMLFile('dtml/270/ordered_manage_main', globals())

    security.declareProtected(ViewManagementScreens, 'manage_object_moveDown')
    def manage_object_moveDown(self, ids=(), steps=1, REQUEST=None, return_view=None):
        """\
        Move the selected object(s) down steps.
        """

        self._objects=tuple(self.moveDown(ids, self._objects, steps=steps))

        if REQUEST is not None:
            if REQUEST.has_key('skey'): REQUEST.set('skey', None)
            if REQUEST.has_key('rkey'): REQUEST.set('rkey', None)
            if type(return_view) is StringType:
                return_view=getattr(self, return_view, None)
            if return_view is not None:
                return  return_view(self, REQUEST, ids=ids, steps=steps, return_view=return_view.__name__)
            return self.manage_main(self, REQUEST, ids=ids, steps=steps, return_view='manage_main')


    security.declareProtected(ViewManagementScreens, 'manage_object_moveUp')
    def manage_object_moveUp(self, ids=(), steps=1, REQUEST=None, return_view=None):
        """\
        Move the selected object(s) down steps.
        """

        self._objects=tuple(self.moveUp(ids, self._objects, steps=steps))

        if REQUEST is not None:
            if REQUEST.has_key('skey'): REQUEST.set('skey', None)
            if REQUEST.has_key('rkey'): REQUEST.set('rkey', None)
            if type(return_view) is StringType:
                return_view=getattr(self, return_view, None)
            if return_view is not None:
                return  return_view(self, REQUEST, ids=ids, steps=steps, return_view=return_view.__name__)
            return self.manage_main(self, REQUEST, ids=ids, steps=steps, return_view='manage_main')

    security.declareProtected(ViewManagementScreens, 'manage_object_moveTop')
    def manage_object_moveTop(self, ids=(), steps=1, REQUEST=None, return_view=None):
        """\
        Move the selected object(s) down steps.
        """

        self._objects=tuple(self.moveTop(ids, self._objects))

        if REQUEST is not None:
            if REQUEST.has_key('skey'): REQUEST.set('skey', None)
            if REQUEST.has_key('rkey'): REQUEST.set('rkey', None)
            if type(return_view) is StringType:
                return_view=getattr(self, return_view, None)
            if return_view is not None:
                return  return_view(self, REQUEST, ids=ids, steps=steps, return_view=return_view.__name__)
            return self.manage_main(self, REQUEST, ids=ids, steps=steps, return_view='manage_main')

    security.declareProtected(ViewManagementScreens, 'manage_object_moveBottom')
    def manage_object_moveBottom(self, ids=(), steps=1, REQUEST=None, return_view=None):
        """\
        Move the selected object(s) to the bottom.
        """

        self._objects=tuple(self.moveBottom(ids, self._objects))

        if REQUEST is not None:
            if REQUEST.has_key('skey'): REQUEST.set('skey', None)
            if REQUEST.has_key('rkey'): REQUEST.set('rkey', None)
            if type(return_view) is StringType:
                return_view=getattr(self, return_view, None)
            if return_view is not None:
                return  return_view(self, REQUEST, ids=ids, steps=steps, return_view=return_view.__name__)
            return self.manage_main(self, REQUEST, ids=ids, steps=steps, return_view='manage_main')


Globals.InitializeClass(OrderedObjectManager)
