##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

__doc__="""\

Utilities for Debugging of Python Code.
from Products.EasyCore.Utils.DebugUtils import MLOG

"""

from zLOG import LOG
from string import join
from Acquisition import aq_chain


def DLOG(message):
    """\
    Prints a message (value) to the Stupie Log File...


    """

    LOG('DLOG',0,message)


def DILOG(i=0, message=''):
    """\
    Prints an integer to the log file,
    returns the incremented integer...


    """
    LOG(message, i, '')
    return i+1

def MLOG( *arg ):
    message=''
    for a in arg:
        message=message + "\t" + str(a)
    LOG('MLOG',0,"\n%s\n" % message)

def MLOG_TAB( *arg ):
    message=''
    for a in arg:
        message=message + "\t" + str(a)
    LOG('MLOG',0,"\n%s\n" % message)

def MLOG_CR( *arg ):
    message=''
    for a in arg:
        message=message + "\n" + str(a)
    LOG('MLOG',0,'', '%s' % message)



def AQ_CHAIN(label, object):
    message=[]
    for ob in aq_chain(object):
        id=getattr(ob, 'getId', None) or getattr(ob, 'id', None) or '--'
        if callable(id): id=id()
        message.append(str(id)+"\t" + str(type(ob)) )
    label=label or getattr(object, 'getPhysicalPath', None) or getattr(object, 'getId', None) or getattr(object, 'id', None) or '--'
    if callable(label): label=label()
    LOG('AQ_CHAIN',0,label, '\n%s\n\n' % join(message, '\n'))


def C_MLOG_TAB(condition=None, *arg ):
    if condition:
        message=''
        for a in arg:
            message=message + "\t" + str(a)
        LOG('MLOG',0,"\n%s\n" % message)