__doc__='''PCounter
$Id: PCounter.py,v 1.1 2004/06/28 10:04:12 johanc Exp $'''
__version__='$Revision: 1.1 $'[11:-2]


#This is browed from Zope 2.4.3 ZODB.tests.ConflictResolution


from Persistence import Persistent

#This PCounter doesn't provide a unique ID.
#It does increment ones per call (even if several threads collide)
#but the value returned will be +2 for both threads.

class PCounter(Persistent):

    _value = 0

    def __init__(self, val=None):
        if val is not None:
            if type(val)==IntType:
                self._value=val
            elif hasattr(val, '_count'):
                self._value=getattr(val, '_count',0)
            else:
                self._value=0

    def __repr__(self):
        return self._value

    def getUniqueId(self):
        self._value = self._value + 1
        return self._value

    def _p_resolveConflict(self, oldState, savedState, newState):
        savedDiff = savedState['_value'] - oldState['_value']
        newDiff = newState['_value'] - oldState['_value']

        oldState['_value'] = oldState['_value'] + savedDiff + newDiff

        return oldState

    # XXX What if _p_resolveConflict _thinks_ it resolved the
    # conflict, but did something wrong?

class PCounter2(PCounter):

    def _p_resolveConflict(self, oldState, savedState, newState):
        raise ConflictError

