
import string, re
from xml.dom import Node
#from xml.dom.ext.Visitor import Visitor, WalkerInterface
from xml.dom.ext.Printer import PrintVisitor, HTML_FORBIDDEN_END
from xml.dom.html import HTML_4_TRANSITIONAL_INLINE

import DOMUtils

class HTMLBodyVisitor(PrintVisitor):

    def _tryIndent(self):
        return

    def _tryCR(self, node):
        if DOMUtils.isBlock(node) and not DOMUtils.isVersionNode(node.parentNode):
            next=DOMUtils.nextNode(node)
            if not next:
                return
            if next.nodeType is Node.TEXT_NODE and '\n' in next.nodeValue:
                return
            self._write('\n')

    def visitProlog(self):
        self._inText = 0
        return

    def visitElement(self, node):
        self._namespaces.append(self._namespaces[-1].copy())
        inline = node.tagName in HTML_4_TRANSITIONAL_INLINE
        DONT_IGNORE=node.tagName.upper() not in ('BODY', 'HTML')
        if DONT_IGNORE:
            self._write('<%s' % node.tagName)
            if self._isXhtml or not self._html:
                namespaces = ''
                if self._isXhtml:
                    nss = {'xml': XML_NAMESPACE, None: XHTML_NAMESPACE}
                else:
                    nss = ext.GetAllNs(node)
                if self._nsHints:
                    self._nsHints.update(nss)
                    nss = self._nsHints
                    self._nsHints = {}
                del nss['xml']
                for prefix in nss.keys():
                    if not self._namespaces[-1].has_key(prefix) or self._namespaces[-1][prefix] != nss[prefix]:
                        nsuri, delimiter = TranslateCdataAttr(nss[prefix])
                        if prefix:
                            xmlns = " xmlns:%s=%s%s%s" % (prefix, delimiter,nsuri,delimiter)
                        else:
                            xmlns = " xmlns=%s%s%s" % (delimiter,nsuri,delimiter)
                        namespaces = namespaces + xmlns

                    self._namespaces[-1][prefix] = nss[prefix]
                self._write(namespaces)
            for attr in node.attributes.values():
                self.visitAttr(attr)
        if len(node.childNodes):
            if DONT_IGNORE:
                self._write('>')
            self._depth = self._depth + 1
            self.visitNodeList(node.childNodes)
            self._depth = self._depth - 1
            if DONT_IGNORE:
                if not self._html or (node.tagName not in HTML_FORBIDDEN_END):
                    not (self._inText and inline) and self._tryIndent()
                    self._write('</%s>' % node.tagName)
        elif not self._html and DONT_IGNORE:
            self._write('/>')
        elif node.tagName not in HTML_FORBIDDEN_END and DONT_IGNORE:
            self._write('></%s>' % node.tagName)
        elif DONT_IGNORE:
            self._write('>')

        self._tryCR(node)

        del self._namespaces[-1]
        self._inText = 0
        return

    def visitDocumentType(self, doctype):
        self._inText = 0
        return

