# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/__init__.py,v 1.1 2004/06/28 10:04:10 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__ = """EasyCore"""
__version__='$Revision: 1.1 $'[11:-2]


from ImageFile import ImageFile


import EasyManagmentTabs
import EasyObjectLink
import EasyObservable
import EasyXMLSupport

import IconMapping
import LinkAssessments
import ManageOptionBase
import PropertyTextParser
import VirtualPath
import VirtualPathHelpers

import EasyJavascriptModules

import EasyIcon
include_modules = (EasyIcon,)

import BodyTabs

import re, mimetypes

from Utils.DebugUtils import *
from AccessControl import ModuleSecurityInfo



def initialize(context):

    security = ModuleSecurityInfo('Products')
    security.declarePublic('EasyCore')
    security = ModuleSecurityInfo('Products.EasyCore')
    security.declarePublic('MLOG_TAB', 'AQ_CHAIN', 'MLOG_CR', 'MLOG', 'DILOG', 'DLOG')

    for m in include_modules:
            m.initialize(context)


#from OFS.misc_ import p_
#p_.ZClass_Icon=Globals.ImageFile('class.gif', globals())

misc_={
    'space.gif':                 ImageFile('images/space.gif',   globals()),
    #Microsoft Office
    'small_icons_doc':           ImageFile('icons/small_icons_doc.gif',   globals(),),
    'small_icons_pdf':           ImageFile('icons/small_icons_pdf.gif',   globals(),),
    'small_icons_ppt':           ImageFile('icons/small_icons_ppt.gif',   globals(),),
    'small_icons_xls':           ImageFile('icons/small_icons_xls.gif',   globals(),),

    #Images
    'image_icons_gif':           ImageFile('icons/image_icons_gif.gif',   globals(),),
    'image_icons_jpg':           ImageFile('icons/image_icons_jpg.gif',   globals(),),
    'image_icons_png':           ImageFile('icons/image_icons_png.gif',   globals(),),
    'image_icons_bmp':           ImageFile('icons/image_icons_bmp.gif',   globals(),),
    'image_icons_pbm':           ImageFile('icons/image_icons_pbm.gif',   globals(),),
    'image_icons_pct':           ImageFile('icons/image_icons_pct.gif',   globals(),),
    'image_icons_tiff':           ImageFile('icons/image_icons_tiff.gif',   globals(),),
    'image_icons_wmf':           ImageFile('icons/image_icons_wmf.gif',   globals(),),
    'image_icons_xpm':           ImageFile('icons/image_icons_xpm.gif',   globals(),),

    'small_icons_bitmap':        ImageFile('icons/Bitmap.gif',   globals(),),
    'small_icons_vector':        ImageFile('icons/Illustrator.gif',   globals(),),
    'small_icons_swf':           ImageFile('icons/flash_swf.gif',   globals(),),

    #Text Object
    'web_icons_html':           ImageFile('icons/web_icons_html.gif',   globals(),),
    'web_icons_css':            ImageFile('icons/web_icons_css.gif',   globals(),),
    'web_icons_js':             ImageFile('icons/web_icons_js.gif',   globals(),),
    'web_icons_text':           ImageFile('icons/web_icons_text.gif',   globals(),),
    'web_icons_xml':            ImageFile('icons/web_icons_js.gif',   globals(),),
    'web_icons_csv':            ImageFile('icons/web_icons_csv.gif',   globals(),),

    #Multimedia
    'small_icons_wav':           ImageFile('icons/WavFile.gif',   globals(),),
    'small_icons_realplayer':    ImageFile('icons/realplayer.gif',   globals(),),
    'small_icons_media':         ImageFile('icons/media.gif',   globals(),),

    #Archives
    'small_icons_winzip':        ImageFile('icons/winzip.gif',   globals(),),
    'small_icons_archive':       ImageFile('icons/winzip.gif',   globals(),),
    'archive_icon_gz':          ImageFile('icons/archive_icons_gz.gif',   globals(),),
    'archive_icons_zip':         ImageFile('icons/archive_icons_zip.gif',   globals(),),
    'archive_icons_tar':         ImageFile('icons/archive_icons_tar.gif',   globals(),),

    #Help Formats
    'small_icons_WinHelp':       ImageFile('icons/WinHelp.gif',   globals(),),
    'small_icons_HTMLHelp':      ImageFile('icons/HTMLHelp.gif',   globals(),),

    #Macromedia
    'small_icons_Dreamweaver':   ImageFile('icons/Dreamweaver.gif',   globals(),),
    'small_icons_FlashMovie':    ImageFile('icons/FlashMovie.gif',   globals(),),

    #Adobe
    'small_icons_Acrobat':       ImageFile('icons/Acrobat.gif',   globals(),),
    'small_icons_Photoshop':     ImageFile('icons/Photoshop_1.gif',   globals(),),
    'small_icons_Illustrator':   ImageFile('icons/Illustrator.gif',   globals(),),
    'small_icons_ImageReady':    ImageFile('icons/ImageReady.gif',   globals(),),
    'small_icons_IndesignDocument':  ImageFile('icons/IndesignDocument.gif',   globals(),),

    #AbiWord
    'small_icons_AbiwordDocbook':    ImageFile('icons/AbiwordDocbook.gif',   globals(),),
    'small_icons_AbiwordDocument':   ImageFile('icons/AbiwordDocument.gif',   globals(),),

    #Web Browsers
    'small_icons_InternetExplorer':  ImageFile('icons/InternetExplorer_1.gif',   globals(),),
    'small_icons_Mozilla':       ImageFile('icons/Mozilla.gif',   globals(),),
    'small_icons_Opera':         ImageFile('icons/Opera.gif',   globals(),),
    'small_icons_Netscape':      ImageFile('icons/Netscape.gif',   globals(),),

    #OpenOffice
    'small_icons_OpenOffice':    ImageFile('icons/openoffice.gif',   globals(),),
    'small_icons_OpenOfficeDrawing':     ImageFile('icons/OpenOfficeDrawing.gif',   globals(),),
    'small_icons_OpenOfficePresentation':    ImageFile('icons/OpenOfficePresentation.gif',   globals(),),
    'small_icons_OpenOfficeSpreadsheet':     ImageFile('icons/OpenOfficeSpreadsheet.gif',   globals(),),
    'small_icons_OpenOfficeText':    ImageFile('icons/OpenOfficeText.gif',   globals(),),

    #Other
    'small_icons_Python':            ImageFile('icons/Python.gif',   globals(),),
    'small_icons_truetype_font':     ImageFile('icons/truetype_font.gif',   globals(),),
    'small_icons_type1_font':        ImageFile('icons/type1_font.gif',   globals(),),

    #Unknown
    'unknown_text_icon':             ImageFile('icons/unknown_text_icon.gif',   globals(),),
    }


# This gives us a hook to add content types that
# aren't currently listed in the mimetypes module.
_addtypes=(
    ('.a', 'application/octet-stream'),
    ('.ai', 'application/postscript'),
    ('.aif', 'audio/x-aiff'),
    ('.aifc', 'audio/x-aiff'),
    ('.aiff', 'audio/x-aiff'),
    ('.au', 'audio/basic'),
    ('.avi', 'video/x-msvideo'),
    ('.bcpio', 'application/x-bcpio'),
    ('.bin', 'application/octet-stream'),
    ('.cdf', 'application/x-netcdf'),
    ('.cpio', 'application/x-cpio'),
    ('.csh', 'application/x-csh'),
    ('.dll', 'application/octet-stream'),
    ('.dvi', 'application/x-dvi'),
    ('.exe', 'application/octet-stream'),
    ('.eps', 'application/postscript'),
    ('.etx', 'text/x-setext'),
    ('.gif', 'image/gif'),
    ('.gtar', 'application/x-gtar'),
    ('.hdf', 'application/x-hdf'),
    ('.htm', 'text/html'),
    ('.html', 'text/html'),
    ('.ief', 'image/ief'),
    ('.jpe', 'image/jpeg'),
    ('.jpeg', 'image/jpeg'),
    ('.jpg', 'image/jpeg'),
    ('.js', 'application/x-javascript'),
    ('.latex', 'application/x-latex'),
    ('.man', 'application/x-troff-man'),
    ('.me', 'application/x-troff-me'),
    ('.mif', 'application/x-mif'),
    ('.mov', 'video/quicktime'),
    ('.movie', 'video/x-sgi-movie'),
    ('.mpe', 'video/mpeg'),
    ('.mpeg', 'video/mpeg'),
    ('.mpg', 'video/mpeg'),
    ('.ms', 'application/x-troff-ms'),
    ('.nc', 'application/x-netcdf'),
    ('.o', 'application/octet-stream'),
    ('.obj', 'application/octet-stream'),
    ('.oda', 'application/oda'),
    ('.pbm', 'image/x-portable-bitmap'),
    ('.pdf', 'application/pdf'),
    ('.pgm', 'image/x-portable-graymap'),
    ('.pnm', 'image/x-portable-anymap'),
    ('.png', 'image/png'),
    ('.ppm', 'image/x-portable-pixmap'),
    ('.py', 'text/x-python'),
    ('.pyc', 'application/x-python-code'),
    ('.ps', 'application/postscript'),
    ('.qt', 'video/quicktime'),
    ('.ras', 'image/x-cmu-raster'),
    ('.rgb', 'image/x-rgb'),
    ('.rdf', 'application/xml'),
    ('.roff', 'application/x-troff'),
    ('.rtf', 'application/rtf'),
    ('.rtx', 'text/richtext'),
    ('.sgm', 'text/x-sgml'),
    ('.sgml', 'text/x-sgml'),
    ('.sh', 'application/x-sh'),
    ('.shar', 'application/x-shar'),
    ('.snd', 'audio/basic'),
    ('.so', 'application/octet-stream'),
    ('.src', 'application/x-wais-source'),
    ('.sv4cpio', 'application/x-sv4cpio'),
    ('.sv4crc', 'application/x-sv4crc'),
    ('.t', 'application/x-troff'),
    ('.tar', 'application/x-tar'),
    ('.tcl', 'application/x-tcl'),
    ('.tex', 'application/x-tex'),
    ('.texi', 'application/x-texinfo'),
    ('.texinfo', 'application/x-texinfo'),
    ('.tif', 'image/tiff'),
    ('.tiff', 'image/tiff'),
    ('.tr', 'application/x-troff'),
    ('.tsv', 'text/tab-separated-values'),
    ('.txt', 'text/plain'),
    ('.ustar', 'application/x-ustar'),
    ('.wav', 'audio/x-wav'),
    ('.xbm', 'image/x-xbitmap'),
    ('.xml', 'text/xml'),
    ('.xsl', 'application/xml'),
    ('.xpm', 'image/x-xpixmap'),
    ('.xwd', 'image/x-xwindowdump'),
    ('.zip', 'application/zip'),

    #From content_types
    ('.mp3', 'audio/mpeg'),
    ('.ra', 'audio/x-pn-realaudio'),
    ('.pdf', 'application/pdf'),
    ('.c', 'text/plain'),
    ('.bat', 'text/plain'),
    ('.h', 'text/plain'),
    ('.pl', 'text/plain'),
    ('.ksh', 'text/plain'),
    ('.ram', 'application/x-pn-realaudio'),
    ('.cdf', 'application-x-cdf'),
    ('.doc', 'application/msword'),
    ('.dot', 'application/msword'),
    ('.wiz', 'application/msword'),
    ('.xlb', 'application/vnd.ms-excel'),
    ('.xls', 'application/vnd.ms-excel'),
    ('.ppa', 'application/vnd.ms-powerpoint'),
    ('.ppt', 'application/vnd.ms-powerpoint'),
    ('.pps', 'application/vnd.ms-powerpoint'),
    ('.pot', 'application/vnd.ms-powerpoint'),
    ('.pwz', 'application/vnd.ms-powerpoint'),
    ('.eml',   'message/rfc822'),
    ('.nws',   'message/rfc822'),
    ('.mht',   'message/rfc822'),
    ('.mhtml', 'message/rfc822'),
    ('.css', 'text/css'),
    ('.p7c', 'application/pkcs7-mime'),
    ('.p12', 'application/x-pkcs12'),
    ('.pfx', 'application/x-pkcs12'),
    ('.js',  'application/x-javascript'),
    ('.pct', 'image/pict'),
    ('.pic', 'image/pict'),
    ('.pict', 'image/pict'),
    ('.m1v', 'video/mpeg'),
    ('.mpa', 'video/mpeg'),
    ('.vcf', 'text/x-vcard'),
    ('.xml', 'text/xml'),
    ('.xsl', 'text/xsl'),
    ('.xul', 'text/xul'),

    #Local
    ('.psd', 'application/photoshop'),
    ('.swf', 'application/x-shockwave-flash'),

)

content_type_to_icon_map= {

        'text/unknown': 'unknown_text_icon' ,
        'text/x-unknown-content-type': 'unknown_text_icon' ,

        'application/pdf': 'small_icons_pdf' ,

        'application/msword': 'small_icons_doc' ,
        'application/rtf': 'small_icons_doc' ,
        'application/vnd.ms-excel': 'small_icons_xls' ,
        'application/x-msexcel': 'small_icons_xls' ,
        'application/x-mspowerpoint': 'small_icons_ppt' ,
        'application/vnd.ms-powerpoint': 'small_icons_ppt' ,

        'text/docbook': 'small_icons_AbiwordDocbook' ,
        'application/abiword': 'small_icons_AbiwordDocument' ,
        'application/abiword-compressed': 'small_icons_AbiwordDocument' ,

        'application/winhlp': 'small_icons_WinHelp' ,
        #'application/?': 'small_icons_HTMLHelp' ,

        #Adobe
        'application/postscript': 'small_icons_Illustrator' ,
        'application/photoshop': 'small_icons_Photoshop' ,
        'application/photoshop': 'small_icons_Photoshop' ,

        #OpenOffice
        'application/x-starwriter': 'small_icons_OpenOffice' ,

        'image/gif': 'image_icons_gif' ,
        'image/jpeg': 'image_icons_jpg' ,
        'image/jpeg': 'image_icons_jpg' ,
        'image/png': 'image_icons_png' ,
        'image/x-png': 'image_icons_png' ,
        'image/bmp': 'image_icons_bmp' ,
        'image/tiff': 'image_icons_tiff' ,
        'image/svg': 'small_icons_vector' ,

        'application/x-shockwave-flash': 'small_icons_swf' ,

        'application/x-pn-realaudio': 'small_icons_realplayer' ,
        'audio/x-pn-realaudio': 'small_icons_realplayer',

        'audio/mpeg': 'small_icons_media',
        'audio/aiff': 'small_icons_media',
        'audio/midi': 'small_icons_media',
        'audio/mp3': 'small_icons_media',
        'audio/wav': 'small_icons_wav',
        'audio/x-aiff': 'small_icons_media',

        'video/mpeg': 'small_icons_media' ,
        'video/x-msvideo': 'small_icons_media' ,
        'video/avi': 'small_icons_media' ,
        'video/mpg': 'small_icons_media' ,
        'video/msvideo': 'small_icons_media' ,
        'video/quicktime': 'small_icons_media' ,

        'text/plain': 'web_icons_text' ,
        'text/html': 'web_icons_html' ,
        'text/css': 'web_icons_css' ,
        'text/js': 'web_icons_js' ,
        'text/xml': 'web_icons_xml' ,
        'text/csv': 'web_icons_csv' ,

        'application/plain': 'web_icons_text' ,
        'application/html': 'web_icons_html' ,
        'application/css': 'web_icons_css' ,
        'application/js': 'web_icons_js' ,
        'application/xml': 'web_icons_xml' ,
        'application/csv': 'web_icons_csv' ,

        'application/zip': 'small_icons_winzip',
        'application/x-zip-compressed': 'small_icons_winzip' ,
        #'application/x-stuffit': 'archive_icons_stuffit' ,
        'application/x-tar': 'archive_icons_tar' ,
        'application/x-gtar': 'archive_icons_tar' ,
        'application/x-compress': 'archive_icon_gz' ,
        'application/x-compressed': 'archive_icon_gz' ,
        'application/x-gzip': 'archive_icon_gz' ,


}


for name, val in _addtypes:
    mimetypes.types_map[name]=val


def fix_base(base):
    if base:
        if base[-1]!='/':
            base=base+'/'
    else:
        base=''
    return base

def getIconpath(content_type, default=None, base='misc_/EasyCore'):
    icon=content_type_to_icon_map.get(content_type, None)
    if icon is not None:
        base=fix_base(base)
        return base+icon
    if default is None:
        kw['src']=base+'unknown_text_icon'
    return default

def renderIconTag(content_type, default=None, base='misc_/EasyCore', *args, **kw):
    icon=content_type_to_icon_map.get(content_type, default)
    kw['src']=getIconpath(content_type, default, base)
    kw['alt']=kw.get('alt', '')
    kw['border']=kw.get('border', '0')
    return '<img  %s/>' % ''.join(map(lambda kvp: ' %s="%s"' %kvp, kw.items()))

def getFileTypeDescription(content_type, default='File'):
    if content_type in ('application/pdf',):
        return 'PDF-file'
    elif content_type in ('application/msword',):
        return 'Microsoft Word'
    elif content_type in ('application/vnd.ms-excel','application/x-msexcel'):
        return 'Microsoft Excel'
    elif content_type in ('application/x-mspowerpoint','application/vnd.ms-powerpoint'):
        return 'Microsoft PowerPoint'
    return default


