from Acquisition import Implicit, aq_inner, aq_parent
from OFS.SimpleItem import Item

class DummyObject(Implicit):
    """
    A dummy callable object.
    Comes with getIcon and restrictedTraverse
    methods.
    """
    def __init__(self, name='dummy',**kw):
        self.name = name
        self.__dict__.update( kw )

    def __str__(self):
        return self.name

    def __call__(self):
        return self.name

    def restrictedTraverse( self, path ):
        return path and getattr( self, path ) or self

    def getIcon( self, relative=0 ):
        return 'Site: %s' % relative
