# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Features/CutCopyPaste.py,v 1.1 2004/06/28 10:04:17 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""CutCopyPaste

$Colliberty: CutCopyPaste.py,v 0.0.1 2001/09/01 10:39:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


class Cut(FeatureBase):
    """Cut Feature"""

    meta_type = 'Cut'
    __plugin_kind__ = 'HTML'

    elementid = 'CutButton'
    command = DECMD_CUT
    accesskey = ''
    actionHandler = 'setCut'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "CutCopyPaste"
    button_group_order = 0


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Cut"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //CUT BUTTON
            function setCut(){
                if(editor.document.queryCommandEnabled(DECMD_CUT))
                    editor.document.execCommand(DECMD_CUT);
            }
        """




Globals.InitializeClass(Cut)

class Copy(FeatureBase):
    """Copy Feature"""

    meta_type = 'Copy'
    __plugin_kind__ = 'HTML'

    elementid = 'CopyButton'
    command = DECMD_COPY
    accesskey = ''
    actionHandler = 'setCopy'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "CutCopyPaste"
    button_group_order = 1


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Copy"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //COPY BUTTON
            function setCopy(){
                if(editor.document.queryCommandEnabled(DECMD_COPY))
                    editor.document.execCommand(DECMD_COPY);
            }
        """



Globals.InitializeClass(Copy)

class Paste(FeatureBase):
    """Paste Feature"""

    meta_type = 'Paste'
    __plugin_kind__ = 'HTML'

    elementid = 'PasteButton'
    command = DECMD_PASTE
    accesskey = ''
    actionHandler = 'setPaste'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "CutCopyPaste"
    button_group_order = 2


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Paste"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //PASTE BUTTON
            function setPaste(){
                if(editor.document.queryCommandEnabled(DECMD_PASTE))
                    editor.document.execCommand(DECMD_PASTE);
            }
        """

Globals.InitializeClass(Paste)



def initialize(context):
    """Initialize Feature Product"""

    context.registerButtonGroup('CutCopyPaste',2)
    context.registerEasyFeature(Cut,Cut.meta_type,icon="icons/Cut.gif")
    context.registerEasyFeature(Copy,Copy.meta_type,icon="icons/Copy.gif")
    context.registerEasyFeature(Paste,Paste.meta_type,icon="icons/Paste.gif")
