# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Features/InlineBold.py,v 1.1 2004/06/28 10:04:17 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""InlineBold

$Colliberty: InlineBold.py,v 0.0.1 2001/06/04 15:37:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION

from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions



FEATUREPLUGINID = 'InlineBold'
PLUGINKIND = 'HTML'

class InlineBold(FeatureBase):
    """InlineBold PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __plugin_kind__ = PLUGINKIND

    elementid = 'boldButton'
    command = DECMD_BOLD
    accesskey = 'b'
    actionHandler = 'setBold'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "TypeStile"
    button_group_order = 0




    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Bold"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)

    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return r"""
            function %(actionHandler)s(){
                if(!document.getElementById('%(elementid)s').disabled&&editor.document.queryCommandSupported(%(command)s)&&editor.document.queryCommandEnabled(%(command)s)) {
                    editor.document.execCommand(%(command)s);
                }
            }
            """ %   {
                        'actionHandler':self.actionHandler,
                        'elementid':self.elementid,
                        'command':self.command
                    }


    def renderjsUpdateApperenceCall(self,client=None,REQUEST=None):
        return r"""
            try {
                if(editor.document.queryCommandEnabled(%(DECMD_BOLD)s)||editor.document.queryCommandSupported(%(DECMD_BOLD)s)){
                    %(elementid)s.className='justplain';
                    %(elementid)s.disabled=false;
                    if (%(elementid)s.children.length>0) {
                        %(elementid)s.children(0).className='';
                    }
                } else {
                    %(elementid)s.className='greyed';
                    %(elementid)s.disabled=true;
                    if (%(elementid)s.children.length>0) {
                        %(elementid)s.children(0).className='IMGGREYED';
                    }
                }

            }
            catch(e) {
                //lert(e);
            }
            """ % {'DECMD_BOLD':DECMD_BOLD,'elementid':self.elementid}


Globals.InitializeClass(InlineBold)


def initialize(context):
    """Initialize Feature Product"""


    context.registerButtonGroup('TypeStile',0)
    context.registerEasyFeature(InlineBold,FEATUREPLUGINID,icon="icons/InlineBoldIcon.gif")
