# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Features/Lists.py,v 1.1 2004/06/28 10:04:17 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""Lists

$Colliberty: Lists.py,v 0.0.1 2001/09/01 10:39:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


class OrderedList(FeatureBase):
    """OrderedList Feature"""

    meta_type = 'OrderedList'
    __plugin_kind__ = 'HTML'

    elementid = 'OrderedListButton'
    command = DECMD_ORDERLIST
    accesskey = ''
    actionHandler = 'setOrderList'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Lists"
    button_group_order = 0


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Ordered List"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //ORDERLIST BUTTON
            function setOrderList(){
                if(editor.document.queryCommandSupported(DECMD_ORDERLIST)&&editor.document.queryCommandEnabled(DECMD_ORDERLIST)) {
                    editor.document.execCommand(DECMD_ORDERLIST);
                }
                handleDisplayChangeEvent();
            }
        """


Globals.InitializeClass(OrderedList)

class UnorderList(FeatureBase):
    """UnorderList Feature"""

    meta_type = 'UnorderList'
    __plugin_kind__ = 'HTML'

    elementid = 'UnorderListButton'
    command = DECMD_UNORDERLIST
    accesskey = ''
    actionHandler = 'setUnorderList'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Lists"
    button_group_order = 1


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //UNORDERLIST BUTTON
            function setUnorderList(){
                if(editor.document.queryCommandSupported(DECMD_UNORDERLIST)&&editor.document.queryCommandEnabled(DECMD_UNORDERLIST)) {
                    editor.document.execCommand(DECMD_UNORDERLIST);
                }
                handleDisplayChangeEvent();
            }
        """




Globals.InitializeClass(UnorderList)



def initialize(context):
    """Initialize Feature Product"""

    context.registerButtonGroup('Lists',5)
    context.registerEasyFeature(OrderedList,OrderedList.meta_type,icon="icons/OrderedList.gif")
    context.registerEasyFeature(UnorderList,UnorderList.meta_type,icon="icons/UnorderList.gif")
