# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Features/RemoveFormat.py,v 1.1 2004/06/28 10:04:17 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""RemoveFormat

$Colliberty: RemoveFormat.py,v 0.0.1 2001/09/01 10:39:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *

from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


class RemoveFormat(FeatureBase):
    """RemoveFormat Feature"""

    meta_type = 'RemoveFormat'
    __plugin_kind__ = 'HTML'

    elementid = 'RemoveFormatButton'
    command = DECMD_REMOVEFORMAT
    accesskey = ''
    actionHandler = 'removeFormat'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Format"
    button_group_order = 0


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Remove format"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //DECMD_REMOVEFORMAT
            function removeFormat(){
                if(editor.document.queryCommandSupported(DECMD_REMOVEFORMAT)&&editor.document.queryCommandEnabled(DECMD_REMOVEFORMAT)) {
                    editor.document.execCommand(DECMD_REMOVEFORMAT);
                }
            }
        """




Globals.InitializeClass(RemoveFormat)




def initialize(context):
    """Initialize Feature Product"""

    context.registerButtonGroup('Format',10)
    context.registerEasyFeature(RemoveFormat,RemoveFormat.meta_type,icon="icons/RemoveFormat.gif")
