# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Storage/ListTypeStorages.py,v 1.1 2004/06/28 10:05:42 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""PropertyStorage

$Colliberty: PropertyStorage.py,v 1.4.37 2001/10/12 18:08:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML
from PropertyStorage import PropertyStorage
from ZPublisher.Converters import type_converters
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base
from types import StringType, ListType, TupleType
from string import atoi, capitalize

from Products.EasyCore import MLOG_TAB

_marker=[]

POSSIBLE_LINES='possible_'

def tuplify(value_list):
    if type(value_list) not in (ListType, TupleType): value_list=[value_list]
    new_list=[]
    add=new_list.append
    for value in value_list:
        if type(value) not in (ListType,TupleType):
            add((value,value))
    return new_list



class ListTypeStorage(PropertyStorage):

    value_type='list'


class LinesPropertyStorage(ListTypeStorage):
    """A LinesPropertyStorage Object """

    property_type = 'lines'
    storage_type="LinesPropertyStorage"
    value_type='list'

    def render_html_view(self, editablecontainer, region):
        req=getattr(editablecontainer ,'REQUEST', None)
        rows=20
        cols=50
        if req is not None and req.has_key('dtpref_cols') and req.has_key('dtpref_rows'):
            dtpref_rows=req.dtpref_rows
            if type(dtpref_rows) is StringType and dtpref_rows[-1]=='%': dtpref_rows=dtpref_rows[:-1]
            rows=max(atoi(dtpref_rows),20)
            dtpref_cols=req.dtpref_cols
            if type(dtpref_cols) is StringType and dtpref_cols[-1]=='%': dtpref_cols=dtpref_cols[:-1]
            cols=max(atoi(dtpref_cols)-15,20)

        lines=self.manage_load(editablecontainer, region, region.getDefault())

        if lines and type(lines)!=StringType:
            lines = '\n'.join(lines)

        return """<textarea name="%s:lines" rows="%s" cols="%s">%s</textarea>"""  % (
                      region.id
                    , rows
                    , cols
                    , lines)

Globals.InitializeClass(LinesPropertyStorage)


class TokensPropertyStorage(ListTypeStorage):
    """A TokensPropertyStorage Object """

    property_type = 'tokens'
    storage_type="TokensPropertyStorage"
    value_type='list'

    def render_html_view(self, editablecontainer, region):
        req=getattr(editablecontainer ,'REQUEST', None)
        cols=50

        if req is not None and req.has_key('dtpref_cols'):
            dtpref_cols=req.dtpref_cols
            if type(dtpref_cols) is StringType and dtpref_cols[-1]=='%': dtpref_cols=dtpref_cols[:-1]
            cols=max(atoi(dtpref_cols)-15,20)

        tokens=self.manage_load(editablecontainer, region, region.getDefault())
        if type(tokens)!=StringType:
            tokens = ' '.join(tokens)
        return """<input type="text" name="%s:tokens" value="%s" size="%s">"""  % (region.id, tokens, cols)


Globals.InitializeClass(TokensPropertyStorage)


def initialize(context):
    """Initialize PropertyStorage"""

    context.registerEasyStorage(LinesPropertyStorage, 'LinesPropertyStorage')
    context.registerEasyStorage(TokensPropertyStorage, 'TokensPropertyStorage')


