# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyFile/MSExcelXMLParser.py,v 1.1 2004/07/19 11:55:05 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""MS Excel XML Parser

ms_excel_xml_parser.py,v 1.8 2001/09/29 12:00:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


from xml.sax import saxutils
from xml.sax import parseString

from ExcelStorage import Sheets

class ExcelHandler(saxutils.DefaultHandler):
    def __init__(self, RowClass=None):
        self.chars=[]
        self.cells=[]
        self.rows=[]
        self.tables=[]

    def characters(self, content):
        self.chars.append(content)

    def startElement(self, name, atts):
        if name=="Cell":
            self.chars=[]
        elif name=="Row":
            self.cells=[]
        elif name=="Table":
            self.rows=[]

    def endElement(self, name):
        if name=="Cell":
            self.cells.append(''.join(self.chars))
        elif name=="Row":
            self.rows.append(self.cells)
        elif name=="Table":
            self.tables.append(self.rows)

excelHandler=ExcelHandler()

def xml_parser(xml_source, SheetClass=None):
    parseString(xml_source, excelHandler)
    #if SheetClass is not None:
    #    sheets=[]
    #    for table in excelHandler.tables:
    #        pass #SheetClass


    return excelHandler.tables
