# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyLanguageService/interfaces/EasyLanguageServiceIf.py,v 1.1 2004/06/28 10:05:45 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#
__doc__='''EasyLanguageService Interface.'''
__version__='$Revision: 1.1 $'[11:-2]

from Interface import Attribute, Base

class LocalNavigationBrain(Base):

     #def _physicalPath(self):
     #   """
     #   """
     #physicalPath = ComputedAttribute(_physicalPath, 1)

     #def _virtualPath(self):
     #   """
     #   """
     #virtualPath = ComputedAttribute(_virtualPath, 1)

     #def _physicalURL(self):
     #   """
     #   """
     #physicalURL = ComputedAttribute(_physicalURL, 1)

     #def _virtualURL(self):
     #   """
     #   """
     #virtualURL = ComputedAttribute(_virtualURL, 1)

     #def _virtualParentPath(self):
     #   """
     #   """
     #virtualParentPath = ComputedAttribute(_virtualParentPath, 1)

     #def _physicalParentPath(self):
     #   """
     #   """
     #physicalParentPath = ComputedAttribute(_physicalParentPath, 1)

     def has_key(self, key):
        """has_key"""
        pass

class QueryInterface(Base):
    """
    The EasyLanguageService is use to keep information about
    language codes (RFS3066) and methods for choosing default
    language (from browser default) an make translations to
    human readable forms.

    Only ISO 639_1: 2-letter codes and combination of ISO 639: 2-letter codes
    and ISO 3166-1 country codes are currently supported.
    This is what is supported by Internet Explorer and possibly other browsers.

    EasyLanguageService also helps a web site register supported
    language versions and the languages base url.

    """

    #meta_type = EASYLANGUAGESERVICE
    #preferred_languages='preferred_languages'
    #_properties = PropertyManager._properties + \
    #manage_options_local =(
    #manage_options = manage_options_local + manage_options_property_manager + manage_options_simple_item


    #############
    #Query Interface
    #############
    #security.declarePublic('getPreferredLanguagesAttributeName')
    def getPreferredLanguagesAttributeName(self):
        """Returns the name of the preferred lanugage request attribute."""

    #security.declarePublic('getPreferredLanguages')
    def getHttpAcceptLanguage(self, REQUEST):
        """

        """


    #security.declarePublic('getPreferredLanguages')
    def getPreferredLanguages(self, use_substitute=1, REQUEST=None):
        """Returns the language code that would be most
        preferred by the user.
        """



    #security.declarePublic('getSubstitute')
    def getSubstitute(self, languages=[]):
        """

        """

    #security.declarePublic('getDefinedLanguages')
    def getDefinedLanguages(self):
        """

        """

    #security.declarePublic('findMatches')
    def findMatches(self, list1, list2, default = []):
        """Returns an intersection of two lists"""



    #security.declarePublic('filterAllowed')
    def filterAllowed(self, languages=[], default=None):
        """Filter languages that are defined with home pages (or none)"""



    #security.declarePublic('getAllowedPreferredLanguages')
    def getAllowedPreferredLanguages(self, use_substitute=1, default=None):
        """Return allowed preferred languages."""



    #security.declarePublic('getCurrentLanguage')
    def getCurrentLanguage(self, use_substitute=1, default='_fail'):
        """Return the allowed preferred language, or default if none."""


    #security.declarePublic('getCurrentLanguageName')
    def getCurrentLanguageName(self, use_substitute=1, default=None):
        """Return allowed preferred language as plain text (English)."""


    #security.declarePublic('getDefaultLanguageCode')
    def getDefaultLanguage(self, default='_fail'):
        """Return first language in defined list."""

    #security.declarePublic('findBestMatch')
    def findBestMatch(self, languages, REQUEST=None):
        """

        """


    #security.declarePublic('getDefaultLanguage')
    def getDefaultLanguageName(self, default=None):
        """Return allowed preferred language."""


    #security.declarePrivate('getFolderURL')
    def getFolderURL(self, lang, default=None):
        """Returns the URL associated with a language code"""

    #security.declarePrivate('getFolder')
    def getFolder(self, lang, default=None):
        """Returns the folder associated with a language code"""

    #security.declarePublic('getCurrentLanguageFolder')
    def getCurrentLanguageFolder(self, use_substitute=1, default=None):
        """Return the current language folder object."""

    #security.declarePublic('getCurrentLanguageFolderAbsoluteURL')
    def getCurrentLanguageFolderAbsoluteURL(self, use_substitute=1, default=None):
        """Return the absolute URL to current language folder."""

    #security.declarePublic('getCurrentLanguageFolderURL')
    def getCurrentLanguageFolderURL(self, use_substitute=1, default=None):
        """Return the virtual URL to current languages folder."""



class ActionInterface(Base):
    """
    Easy Languages Service Action Interface
    """
    #security.declarePublic('redirect')
    def redirect(self, use_substitute=1, default=None, lock=1):
        """Redirect to the Language Folder, and ignore exceptions that may be raise after this."""



    # Language Query Interface

class LanguageQueryInterfaceInterface(Base):
    """\
    Easy Language Service Query Interface
    """

    def getLanguageItemsByCodes(lang_codes):
        """
        Returns all languages in lang_codes as (RFC3066, PlainText)
            lang_codes is a list of RFC3066 codes.

        TODO: Language Item should be sorted on the Languages Plain Text
              (language codes are not alphabetically ordered)
        """

    def getAllLanguageIds(self, filter_codes=[]):
        """\
        Returns all languages as RFC3066 codes
        except for those in filter_codes

        filter_codes is a sequence of RFC3066 code.
        """

    def getAllLanguageValues(self, filter_codes=[]):
        """\
        Returns all languages as PlainText
        except for those in filter_codes

        filter_codes is a sequence of RFC3066 code.
        """
        return getCountryValues(country_codes)

    #security.declarePublic('getAllLanguageItems')
    def getAllLanguageItems(self, filter_codes=[]):
        """\
        Returns all languages as (RFC3066, PlainText)

        filter_codes is a sequence of RFC3066 code of languages
        that should be excluded from the result.
        """

class CountryQueryInterfaceInterface(Base):
    """\
    Easy Country Service Query Interface
    """

    def getCountryItemsByCodes(self, country_codes):
        """\
        Returns all languages in country_codes as (ISO639_1, PlainText)
        """

    def getAllCountryIds(self, filter_codes=[]):
        """/
        Returns all countries as ISO639_1 codes
        except for those in filter_codes

        filter_codes is a sequence of ISO639_1 code.
        """

    def getAllCountryValues(self, filter_codes=[]):
        """\
        Returns all countries  as PlainText
        except for those in filter_codes

        filter_codes is a sequence of ISO639_1 code.
        """
        return getCountryValues(country_codes)

    def getAllCountryItems(self, filter_codes=[]):
        """
        Returns all languages as (ISO639_1, PlainText) except for the once in filter_codes.

        filter_codes is a sequence of ISO639_1 code.
        """


class SessionInterface(Base):
    """\
    Easy Language Service Session Interface
    """

    # Session Interface
    #security.declarePublic('setPreferredLanguageInSession')
    def setPreferredLanguageInSession(self, language=None, REQUEST=None):
        """Sets a cookie with the preferred language."""

    #security.declarePublic('removePreferredLanguageInSession')
    def removePreferredLanguageInSession(self, REQUEST=None):
        """Removes the cookie with the preferred language."""


    #security.declarePublic('getPreferredLanguageInSession')
    def getPreferredLanguageInSession(self, default=None, REQUEST=None):
        """Gets the cookie with the preferred language or default."""


class RFCISOQueryInterface(Base):
    """
    Easy Language Service RFC/ISO Query  Interface
    """



    #security.declarePublic('getLanguageByRFC3066')
    def getLanguageByRFC3066(self, code, default='English'):
        """Translates a language code to a human readable form in english.

        If a sequence of language codes is passed, a sequence of the corresponding
        languages is returns.
        """

    #security.declarePublic('getLanguageByISO639_1')
    def getLanguageByISO639_1(self, code, default='English'):
        """Translates a language code to a human readable form in english.

        If a sequence of language codes is passed, a sequence of the corresponding
        languages is returns.
        """

    #security.declarePublic('getCountryByISO3166_1')
    def getCountryByISO3166_1(self, code, default='United States'):
        """Translates a language code to a human readable form in english.

        If a sequence of language codes is passed, a sequence of the corresponding
        languages is returns.
        """

    #security.declarePublic('getRFC3066ByLanguage')
    def getRFC3066ByLanguage(self, language, default='en'):
        """Translates a language in a human readable form to the code.
        """

    #security.declarePublic('getISO639_1ByLanguage')
    def getISO639_1ByLanguage(self, language, default='en'):
        """Translates a language in a human readable form to the code."""

    #security.declarePublic('getISO3166_1ByCountry')
    def getISO3166_1ByCountry(self, country, default='en'):
        """Translates a language in a human readable form to the code."""

    #security.declarePublic('getISO639_1ByRFC3066')
    def getISO639_1ByRFC3066(self, code):
        """
        Returns the root language class of the language code.

        If a sequence of language codes is passed, a tuple of the corresponding
        languages is returns.
        """

    #security.declarePublic('validISO639_1')
    def validISO639_1(self, code):
        """
        Returnes true if this is a valid language code.
        """

    #security.declarePublic('validRFC3066')
    def validRFC3066(self, code):
        """
        Returnes true if this is a valid language code.
        """

    #security.declarePublic('validISO3166_1')
    def validISO3166_1(self, code):
        """
        Returnes true if this is a valid language code.
        """


class EasyLanguageServiceManagementInterface(Base):
    """
    Easy Language Service Management Interface
    """

    #security.declareProtected(EasyLanguageServiceManage, 'manage_main')
    def manage_main(self
                    , selected_language=[]
                    , add_language=None
                    , add_folder_url=None
                    , action='View'
                    , REQUEST=None):
        """Manage Language Folders"""

    #security.declareProtected(EasyLanguageServiceManage, 'manage_mappings')
    def manage_mappings(self
                    , selected_mappings=[]
                    , add_mapping=None
                    , add_languages=[]
                    , action='View'
                    , REQUEST=None):
        """Manage Language Folders"""


    #security.declarePublic('relativeUrl')
    def relativeUrl(self, absolute_url, REQUEST=None):
        """

        """

    #security.declarePublic('getLanguageFolderItems')
    def getLanguageFolderItems(self,spec=None):
        """Returns Language Folder itemes in sorted order"""

    #security.declarePublic('getLanguageFolderKeys')
    def getLanguageFolderKeys(self, extra=[]):
        """Returns Language Folder keys (plus extra) in sorted order"""

    #security.declarePublic('getLanguageMappingItems')
    def getLanguageMappingItems(self,spec=None):
        """

        """

    #security.declarePublic('getLanguageMappingKeys')
    def getLanguageMappingKeys(self,spec=None):
        """

        """

    #security.declarePublic('getLanguageMappingUsedKeys')
    def getLanguageMappingUsedKeys(self,spec=[]):
        """Returns all unique ids that has a mapping or is mapped from."""

    #security.declarePublic('getLanguageMappedKeys')
    def getLanguageMappedKeys(self):
        """Returns all unique ids that is mapping to another language."""

    #security.declarePublic('getLanguageItemsByCode')
    def getLanguageItemsByCode(self, lang_codes=[]):
        """\
        Returns all languages in lang_codes as (rfc3066Code, PlainText)
        """



class NavigationInterface(Base):
    """
    Easy Language Service Navigation Interface
    """

    #security.declarePublic(View, 'getMenu')
    def getMenu(self, object_path, sort_on='order', sort_order=None, skip_root=None):
        """

        """

