# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyPresentationHelpers/HiddenFieldsForLinkGroups.py,v 1.1 2004/06/28 10:05:47 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__='''DTMLLink
$Id: HiddenFieldsForLinkGroups.py,v 1.1 2004/06/28 10:05:47 johanc Exp $'''
__version__='$Revision: 1.1 $'[11:-2]

import string
from DocumentTemplate.DT_Util   import *
from DocumentTemplate.DT_String import String
from DocumentTemplate.DT_Util import parse_params,render_blocks
from types import ListType, StringType, TupleType
SeqvenceType = (ListType,TupleType)

from Products.EasyCore.TagUtils import SingleTagBase, STRING_PARAM




class HiddenFieldsForLinkGroups(SingleTagBase):
    """\
    HiddenFieldsForLinkGroups Tag
    """

    name='hiddenfieldforlinkgroups'
    expr=None

    attributes={
      'linkgroups': {'value':'', 'required':0,'type':STRING_PARAM},
    }

    def do_render(self, md, object):

        #url = getattr(md, 'url', '')
        #stitle = getattr(md, 'stitle', '')
        result = ''
        if md and md.has_key('sortlinkgroups'):
            for key,value in md['sortlinkgroups']:
                if not (md.has_key(key+"_rendered") and md[key+"_rendered"]):
                    if md.has_key(key): value = md[key]
                    if type(value) in SeqvenceType:
                        for v in value:
                            result = result + '<input type="hidden" name="%s" value="%s">' % (key,v)
                    else:
                        result = result + '<input type="hidden" name="%s" value="%s">' % (key,value)
        return result


String.commands[HiddenFieldsForLinkGroups.name] = HiddenFieldsForLinkGroups

