# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyPresentationHelpers/LinkGroup.py,v 1.1 2004/06/28 10:05:47 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__='''LinkGroup
$Id: LinkGroup.py,v 1.1 2004/06/28 10:05:47 johanc Exp $'''
__version__='$Revision: 1.1 $'[11:-2]

import string
from DocumentTemplate.DT_String import String

from Products.EasyCore.TagUtils import ContainerTagBase, STRING_PARAM

from Products.EasyCore import MLOG_TAB


class LinkGroup(ContainerTagBase):
    """\
    LinkGroup Tag
    """

    name='linkgroup'
    blockContinuations=()


    attributes={
      'action':     {'value':'', 'required':1,'type':STRING_PARAM},
      'method':     {'value':'post', 'required':1,'type':STRING_PARAM},
      'encoding':   {'value':'', 'required':0,'type':STRING_PARAM},
    }


    def do_render(self, md, object):

        action = getattr(md, 'action', self.action)
        method = getattr(md, 'method', self.method)
        encoding = getattr(md, 'encoding', self.encoding)

        result = '<form action="%s" method="%s"' % (action, method)
        if encoding: result = result + ' encoding="%s"' % (encoding)
        result = result + ">%s</form>" % self.render_blocks(md)
        return result


String.commands[LinkGroup.name] = LinkGroup

