#####################################################################
#
# Xron -- Zope Scheduled Event Product
# Copyright (C) 2000 Loren Stafford
#
# Derived from the ZScheduler product version 0.0.7 in accord
# with the terms of the ZScheduler's license.
#
# Based on code by Martijn Pieters, (c) 1999 Antraciet B.V.
# Used with explicit permission.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
#         Free Software Foundation, Inc.,
#         59 Temple Place - Suite 330,
#         Boston, MA    02111-1307, USA.
#
#####################################################################
""" TimeAritmetics """

from DateTime import DateTime
import calendar

SECONDS_PER_YEAR   = 364*24*60*60
SECONDS_PER_WEEK   =   7*24*60*60
SECONDS_PER_DAY    =     24*60*60
SECONDS_PER_HOUR   =        60*60
SECONDS_PER_MINUTE =           60


def addYears(now, years):
    nowinseconds=now.timeTime()
    cyear=now.year()
    cmonth=now.month()
    skip_feb=cmonth>2
    leaps=calendar.leapdays(cyear+skip_feb, cyear+years+skip_feb)
    days=365*years+leaps
    nowinseconds=nowinseconds+SECONDS_PER_DAY*days
    now=DateTime(nowinseconds)
    return now

def addMonths(now, months):
    nowinseconds=now.timeTime()
    cyear=now.year()
    cmonth=now.month()
    while months>0:
        days=calendar.monthrange(cyear, cmonth)[1]
        nowinseconds=nowinseconds+SECONDS_PER_DAY*days
        cmonth=cmonth+1
        if cmonth>12:
            cyear=cyear+1
            cmonth=1
        months=months-1
    now=DateTime(nowinseconds)
    return now

def addWeeks(now, weeks):
    nowinseconds=now.timeTime()
    nowinseconds=nowinseconds+SECONDS_PER_WEEK*weeks
    now=DateTime(nowinseconds)
    return now

def addDays(now, days):
    nowinseconds=now.timeTime()
    nowinseconds=nowinseconds+SECONDS_PER_DAY*days
    now=DateTime(nowinseconds)
    return now

def addHours(now, hours):
    nowinseconds=now.timeTime()
    nowinseconds=nowinseconds+SECONDS_PER_HOUR*hours
    now=DateTime(nowinseconds)
    return now

def addMinutes(now, minutes):
    nowinseconds=now.timeTime()
    nowinseconds=nowinseconds+SECONDS_PER_MINUTE*minutes
    now=DateTime(nowinseconds)
    return now

