# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/ZMIPatch/OFS_FindSupport/__init__.py,v 1.2 2004/07/01 10:46:37 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#


__doc__ = 'Add a Replace tab to Folders'
__version__ = '1.8'


from zLOG import LOG
from Globals import InitializeClass, DTMLFile
from OFS.FindSupport import FindSupport
from Products.ReplaceSupport.ReplaceSupport import ReplaceSupport
from AccessControl import ClassSecurityInfo
from Products.EasyCore.BodyTabs import InitializeBodyTabs, UpdateTab


ViewManagementScreens = 'View management screens'
SearchReplaceInObjects = 'Search & replace in objects'

securityFindSupport = ClassSecurityInfo()
options=()
for option in FindSupport.manage_options:
    if option.get('action','')=='manage_findForm':
        option['label']='Find&Replace'
    options=options+(option,)
FindSupport.manage_options = options

securityFindSupport.declareProtected(ViewManagementScreens, 'manage_replaceForm')
FindSupport.manage_replaceForm = ReplaceSupport.manage_replaceForm
UpdateTab(FindSupport.manage_replaceForm, order=3)

securityFindSupport.declareProtected(ViewManagementScreens, 'manage_replaceResult')
FindSupport.manage_replaceResult = ReplaceSupport.manage_replaceResult
UpdateTab(FindSupport.manage_replaceResult, order=4, label='Result', selectable=0, management_view='Find&Replace')

securityFindSupport.declareProtected(ViewManagementScreens, 'getReplaceHandlerMetaTypes')
FindSupport.getReplaceHandlerMetaTypes = ReplaceSupport.getReplaceHandlerMetaTypes

securityFindSupport.declareProtected(SearchReplaceInObjects, 'ZopeReplace')
FindSupport.ZopeReplace = ReplaceSupport.ZopeReplace

securityFindSupport.declareProtected(SearchReplaceInObjects, 'PrincipiaReplace')
FindSupport.PrincipiaReplace = ReplaceSupport.ZopeReplace
FindSupport._ZopeReplace = ReplaceSupport._ZopeReplace
FindSupport._PrincipiaReplace = ReplaceSupport._ZopeReplace
#FindSupport._ReplaceHandlerRegistry = ReplaceSupport._ReplaceHandlerRegistry


from App.version_txt import getZopeVersion
zope_version=getZopeVersion()

if zope_version[0:3]>=(2,7,0) and zope_version[0:3] < (2,8,0):

    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findForm')
    FindSupport.manage_findForm=DTMLFile('dtml/Zope270/findForm', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Simple','order':1, 'management_view':'Find&Replace'}
                            )

    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findAdv')
    FindSupport.manage_findAdv=DTMLFile('dtml/Zope270/findAdv', globals()
                            , management_view='Find&Replace'
                            , help_topic='Find_Advanced.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Advanced','order':2, 'management_view':'Find&Replace'}
                            )
    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findResult')
    FindSupport.manage_findResult=DTMLFile('dtml/Zope270/findResult', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Result','order':4, 'management_view':'Find&Replace', 'selectable':0}
                            )
if zope_version[0:3]>=(2,6,1) and zope_version[0:3] < (2,7,0):

    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findForm')
    FindSupport.manage_findForm=DTMLFile('dtml/Zope261/findForm', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Simple','order':1, 'management_view':'Find&Replace'}
                            )

    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findAdv')
    FindSupport.manage_findAdv=DTMLFile('dtml/Zope261/findAdv', globals()
                            , management_view='Find&Replace'
                            , help_topic='Find_Advanced.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Advanced','order':2, 'management_view':'Find&Replace'}
                            )
    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findResult')
    FindSupport.manage_findResult=DTMLFile('dtml/Zope261/findResult', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Result','order':4, 'management_view':'Find&Replace', 'selectable':0}
                            )
elif zope_version[0:3]>=(2,5,1) and zope_version[0:3] < (2,6,1):
    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findForm')
    FindSupport.manage_findForm=DTMLFile('dtml/Zope251/findForm', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Simple','order':1, 'management_view':'Find&Replace'}
                            )

    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findAdv')
    FindSupport.manage_findAdv=DTMLFile('dtml/Zope251/findAdv', globals()
                            , management_view='Find&Replace'
                            , help_topic='Find_Advanced.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Advanced','order':2, 'management_view':'Find&Replace'}
                            )
    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findResult')
    FindSupport.manage_findResult=DTMLFile('dtml/Zope251/findResult', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Result','order':4, 'management_view':'Find&Replace', 'selectable':0}
                            )
else:

    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findForm')
    FindSupport.manage_findForm=DTMLFile('dtml/Zope270/findForm', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Simple','order':1, 'management_view':'Find&Replace'}
                            )

    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findAdv')
    FindSupport.manage_findAdv=DTMLFile('dtml/Zope270/findAdv', globals()
                            , management_view='Find&Replace'
                            , help_topic='Find_Advanced.stx'
                            , help_product='OFSP'
                            , body_tab={'label':'Advanced','order':2, 'management_view':'Find&Replace'}
                            )
    securityFindSupport.declareProtected(ViewManagementScreens, 'manage_findResult')
    FindSupport.manage_findResult=DTMLFile('dtml/Zope270/findResult', globals()
                            , management_view='Find&Replace'
                            , body_tab={'label':'Result','order':4, 'management_view':'Find&Replace', 'selectable':0}
                            )

FindSupport.security=securityFindSupport
InitializeClass(FindSupport)
InitializeBodyTabs(FindSupport)


